/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Normal
* Screen size : <480,272>
*
*******************************************************************************/

#ifndef Views_H
#define Views_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_ViewsImage.h"
#include "_ViewsRectangle.h"
#include "_ViewsText.h"

/* The definition Views::ImageAlignment determines the set of constraints to apply 
   on a bitmap if its size differ from the size of the view where the bitmap is 
   shown. Depending on the active constraints a bitmap can be aligned or stretched 
   within the view's area. */
typedef XSet ViewsImageAlignment;

#define ViewsImageAlignmentAlignHorzLeft                    0x00000001
#define ViewsImageAlignmentAlignHorzCenter                  0x00000002
#define ViewsImageAlignmentAlignHorzRight                   0x00000004
#define ViewsImageAlignmentAlignVertTop                     0x00000008
#define ViewsImageAlignmentAlignVertCenter                  0x00000010
#define ViewsImageAlignmentAlignVertBottom                  0x00000020
#define ViewsImageAlignmentScaleToFill                      0x00000040
#define ViewsImageAlignmentScaleToFit                       0x00000080
#define ViewsImageAlignmentStretchToFill                    0x00000100

/* The definition Views::TextAlignment determines the set of constraints to apply 
   on text rows and blocks if their size differ from the size of the view where 
   the text is shown. Depending on the active constraints the text rows can be aligned 
   horizontally and text blocks vertically. */
typedef XSet ViewsTextAlignment;

#define ViewsTextAlignmentAlignHorzLeft                     0x00000001
#define ViewsTextAlignmentAlignHorzCenter                   0x00000002
#define ViewsTextAlignmentAlignHorzRight                    0x00000004
#define ViewsTextAlignmentAlignVertTop                      0x00000008
#define ViewsTextAlignmentAlignVertCenter                   0x00000010
#define ViewsTextAlignmentAlignVertBottom                   0x00000020
#define ViewsTextAlignmentAlignHorzJustified                0x00000040
#define ViewsTextAlignmentAlignHorzAuto                     0x00000080
#define ViewsTextAlignmentAlignVertCenterBaseline           0x00000100

/* The definition Views::Orientation determines the possible options to control 
   the orientation of the content displayed in the Views::Image, Views::Group and 
   Views::Text views. Depending on the selected option the view displays the content 
   rotated. */
typedef XEnum ViewsOrientation;

#define ViewsOrientationNormal                              0
#define ViewsOrientationRotated_90                          1
#define ViewsOrientationRotated_180                         2
#define ViewsOrientationRotated_270                         3

#ifdef __cplusplus
  }
#endif

#endif /* Views_H */

/* Embedded Wizard */
