/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Normal
* Screen size : <480,272>
*
*******************************************************************************/

#ifndef Climate_H
#define Climate_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_ClimateButton.h"
#include "_ClimateClimate.h"
#include "_ClimateDataItem.h"
#include "_ClimateDeviceClass.h"
#include "_ClimateDiagram.h"
#include "_ClimateMenuItem.h"
#include "_ClimateSliderItem.h"
#include "_ClimateStartButton.h"
#include "_ClimateStatusBar.h"

/* This is a font resource. */
EW_DECLARE_FONT_RES( ClimateMediumFont )

/* This is a font resource. */
EW_DECLARE_FONT_RES( ClimateLargeFont )

/* This is a bitmap resource. */
EW_DECLARE_BITMAP_RES( ClimateEdge )

/* This is a bitmap resource. */
EW_DECLARE_BITMAP_RES( ClimateWiper )

/* This is a font resource. */
EW_DECLARE_FONT_RES( ClimateSmallFont )

/* This is a bitmap resource. */
EW_DECLARE_BITMAP_RES( ClimateDashLineV )

/* This is a bitmap resource. */
EW_DECLARE_BITMAP_RES( ClimateDashLineH )

/* This is a bitmap resource. */
EW_DECLARE_BITMAP_RES( ClimateTriangle )

/* This is a bitmap resource. */
EW_DECLARE_BITMAP_RES( ClimateThumb )

/* Color constant according UI design. */
extern const XColor ClimateBorderColor;

/* Color constant according UI design. */
extern const XColor ClimateBackColor;

/* Color constant according UI design. */
extern const XColor ClimateSelectColor;

/* Color constant according UI design. */
extern const XColor ClimateStartColor;

/* Color constant according UI design. */
extern const XColor ClimateGraphColor;

/* Color constant according UI design. */
extern const XColor ClimateTextColor;

/* Constant to define the spacing between the menu items. */
extern const XPoint ClimateSpacing;

/* Constant to define the size of a single menu item */
extern const XPoint ClimateMenuItemSize;

/* Constant to define the size of a single data item. */
extern const XPoint ClimateDataItemSize;

/* Constant to define the size of a single data item. */
extern const XPoint ClimateDataItemSizeLarge;

/* Constant to define the size of the diagram. */
extern const XRect ClimateChartStopPos;

/* Color constant according UI design. */
extern const XColor ClimateHumidityColor;

/* Constant to define the size of the diagram. */
extern const XRect ClimateChartStartPos;

/* Constant to define the size of the diagram. */
extern const XRect ClimateStartButtonPos;

/* Constant to define the size of the diagram. */
extern const XRect ClimateStatusBarPos;

/* Constant to define the size of the slider item */
extern const XPoint ClimateSliderSize;

/* This is an enumeration definition for signing the different menu items. */
typedef XEnum ClimateMenuType;

#define ClimateMenuTypeTempHumid                            0
#define ClimateMenuTypeDwellTime                            1
#define ClimateMenuTypeHeatCool                             2

/* User defined auto object: 'Climate::Device' */
EW_DECLARE_AUTOOBJECT( ClimateDevice, ClimateDeviceClass )

/* This is an enumeration definition for the different unit types used for displaying 
   values. */
typedef XEnum ClimateUnitType;

#define ClimateUnitTypeTime                                 0
#define ClimateUnitTypePercent                              1
#define ClimateUnitTypeTemperature                          2

#ifdef __cplusplus
  }
#endif

#endif /* Climate_H */

/* Embedded Wizard */
