/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Normal
* Screen size : <480,272>
*
*******************************************************************************/

#ifndef _ChartsGraph_H
#define _ChartsGraph_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_CoreGroup.h"
#include "_ViewsRectangle.h"

/* Forward declaration of the class Charts::CoordList */
#ifndef _ChartsCoordList_
  EW_DECLARE_CLASS( ChartsCoordList )
#define _ChartsCoordList_
#endif

/* Forward declaration of the class Charts::Graph */
#ifndef _ChartsGraph_
  EW_DECLARE_CLASS( ChartsGraph )
#define _ChartsGraph_
#endif

/* Forward declaration of the class Core::KeyPressHandler */
#ifndef _CoreKeyPressHandler_
  EW_DECLARE_CLASS( CoreKeyPressHandler )
#define _CoreKeyPressHandler_
#endif

/* Forward declaration of the class Core::LayoutContext */
#ifndef _CoreLayoutContext_
  EW_DECLARE_CLASS( CoreLayoutContext )
#define _CoreLayoutContext_
#endif

/* Forward declaration of the class Core::View */
#ifndef _CoreView_
  EW_DECLARE_CLASS( CoreView )
#define _CoreView_
#endif

/* Forward declaration of the class Graphics::Canvas */
#ifndef _GraphicsCanvas_
  EW_DECLARE_CLASS( GraphicsCanvas )
#define _GraphicsCanvas_
#endif

/* Forward declaration of the class Resources::Bitmap */
#ifndef _ResourcesBitmap_
  EW_DECLARE_CLASS( ResourcesBitmap )
#define _ResourcesBitmap_
#endif


/* The class 'Graph' implements a GUI component for displaying a complete graph 
   diagram. The data for the single dots and lines are defined within a @CoordList. */
EW_DEFINE_FIELDS( ChartsGraph, CoreGroup )
  EW_OBJECT  ( Background,      ViewsRectangle )
  EW_PROPERTY( Coordinates,     ChartsCoordList )
  EW_PROPERTY( LineBitmap,      ResourcesBitmap )
  EW_PROPERTY( DotBitmap,       ResourcesBitmap )
  EW_PROPERTY( LineColor,       XColor )
  EW_PROPERTY( LineWidth,       XFloat )
  EW_PROPERTY( DotColor,        XColor )
  EW_PROPERTY( DotWidth,        XFloat )
  EW_PROPERTY( CoordOrigin,     XPoint )
  EW_PROPERTY( PixelPerUnit,    XPoint )
  EW_PROPERTY( BackColor,       XColor )
  EW_PROPERTY( HorzGridColor,   XColor )
  EW_PROPERTY( VertGridColor,   XColor )
  EW_PROPERTY( GridDistance,    XPoint )
EW_END_OF_FIELDS( ChartsGraph )

/* Virtual Method Table (VMT) for the class : 'Charts::Graph' */
EW_DEFINE_METHODS( ChartsGraph, CoreGroup )
  EW_METHOD( initLayoutContext, void )( CoreRectView _this, XRect aBounds, CoreOutline 
    aOutline )
  EW_METHOD( GetRoot,           CoreRoot )( CoreView _this )
  EW_METHOD( Draw,              void )( ChartsGraph _this, GraphicsCanvas aCanvas, 
    XRect aClip, XPoint aOffset, XInt32 aOpacity, XBool aBlend )
  EW_METHOD( GetClipping,       XRect )( CoreGroup _this )
  EW_METHOD( HandleEvent,       XObject )( CoreView _this, CoreEvent aEvent )
  EW_METHOD( CursorHitTest,     CoreCursorHit )( CoreGroup _this, XRect aArea, XInt32 
    aFinger, XInt32 aStrikeCount, CoreView aDedicatedView, CoreView aStartView, 
    XSet aRetargetReason )
  EW_METHOD( AdjustDrawingArea, XRect )( CoreGroup _this, XRect aArea )
  EW_METHOD( ArrangeView,       XPoint )( CoreRectView _this, XRect aBounds, XEnum 
    aFormation )
  EW_METHOD( MoveView,          void )( CoreRectView _this, XPoint aOffset, XBool 
    aFastMove )
  EW_METHOD( GetExtent,         XRect )( CoreRectView _this )
  EW_METHOD( ChangeViewState,   void )( CoreGroup _this, XSet aSetState, XSet aClearState )
  EW_METHOD( OnSetBounds,       void )( CoreGroup _this, XRect value )
  EW_METHOD( OnSetFocus,        void )( CoreGroup _this, CoreView value )
  EW_METHOD( DispatchEvent,     XObject )( CoreGroup _this, CoreEvent aEvent )
  EW_METHOD( BroadcastEvent,    XObject )( CoreGroup _this, CoreEvent aEvent, XSet 
    aFilter )
  EW_METHOD( UpdateLayout,      void )( CoreGroup _this, XPoint aSize )
  EW_METHOD( UpdateViewState,   void )( CoreGroup _this, XSet aState )
  EW_METHOD( InvalidateArea,    void )( CoreGroup _this, XRect aArea )
EW_END_OF_METHODS( ChartsGraph )

/* 'C' function for method : 'Charts::Graph.Draw()' */
void ChartsGraph_Draw( ChartsGraph _this, GraphicsCanvas aCanvas, XRect aClip, XPoint 
  aOffset, XInt32 aOpacity, XBool aBlend );

/* 'C' function for method : 'Charts::Graph.OnSetCoordinates()' */
void ChartsGraph_OnSetCoordinates( ChartsGraph _this, ChartsCoordList value );

/* 'C' function for method : 'Charts::Graph.OnSetLineColor()' */
void ChartsGraph_OnSetLineColor( ChartsGraph _this, XColor value );

/* 'C' function for method : 'Charts::Graph.OnSetLineWidth()' */
void ChartsGraph_OnSetLineWidth( ChartsGraph _this, XFloat value );

/* 'C' function for method : 'Charts::Graph.OnSetDotColor()' */
void ChartsGraph_OnSetDotColor( ChartsGraph _this, XColor value );

/* 'C' function for method : 'Charts::Graph.OnSetDotWidth()' */
void ChartsGraph_OnSetDotWidth( ChartsGraph _this, XFloat value );

/* 'C' function for method : 'Charts::Graph.OnSetCoordOrigin()' */
void ChartsGraph_OnSetCoordOrigin( ChartsGraph _this, XPoint value );

/* 'C' function for method : 'Charts::Graph.OnSetPixelPerUnit()' */
void ChartsGraph_OnSetPixelPerUnit( ChartsGraph _this, XPoint value );

/* 'C' function for method : 'Charts::Graph.OnSetBackColor()' */
void ChartsGraph_OnSetBackColor( ChartsGraph _this, XColor value );

/* 'C' function for method : 'Charts::Graph.OnSetHorzGridColor()' */
void ChartsGraph_OnSetHorzGridColor( ChartsGraph _this, XColor value );

/* 'C' function for method : 'Charts::Graph.OnSetVertGridColor()' */
void ChartsGraph_OnSetVertGridColor( ChartsGraph _this, XColor value );

/* 'C' function for method : 'Charts::Graph.OnSetGridDistance()' */
void ChartsGraph_OnSetGridDistance( ChartsGraph _this, XPoint value );

/* 'C' function for method : 'Charts::Graph.OnSetDotBitmap()' */
void ChartsGraph_OnSetDotBitmap( ChartsGraph _this, ResourcesBitmap value );

#ifdef __cplusplus
  }
#endif

#endif /* _ChartsGraph_H */

/* Embedded Wizard */
