@echo off
SETLOCAL EnableDelayedExpansion

set out_file="%EmWi_OutputDirectory%\ewfiles.gpdsc"

set rte_path=..\..\PlatformPackage\RTE
set gfx_path=..\..\PlatformPackage\%EmWi_ColorFormat%

date /t > date.tmp
time /t > time.tmp
for /f %%i IN (date.tmp) DO SET cur_date=%%i
for /f %%i IN (time.tmp) DO SET cur_time=%%i
del date.tmp time.tmp


if exist "%EmWi_OutputDirectory%/../../PlatformPackage/%EmWi_ColorFormat%/ewgfx.c" (
  set EmWi_RTESrcFiles=ewcolor.c ewdebug.c ewextrte.c ewobject.c ewpoint.c ewrect.c ewref.c ewresource.c ewscalars.c ewslot.c ewstring.c ewtimer.c ewheap.c ewinvocations.c

  if %EmWi_ColorFormat% == Index8 (
    set EmWi_GFX_SrcFiles=ewextbmp_Index8.c ewextfnt.c ewextgfx.c ewextpxl_Index8.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
  if %EmWi_ColorFormat% == LumA44 (
    set EmWi_GFX_SrcFiles=ewextbmp_LumA44.c ewextfnt.c ewextgfx.c ewextpxl_LumA44.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
  if %EmWi_ColorFormat% == RGB565 (
    set EmWi_GFX_SrcFiles=ewextbmp_RGB565.c ewextfnt.c ewextgfx.c ewextpxl_RGB565.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
  if %EmWi_ColorFormat% == RGB888 (
    set EmWi_GFX_SrcFiles=ewextbmp_RGB888.c ewextfnt.c ewextgfx.c ewextpxl_RGB888.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
  if %EmWi_ColorFormat% == RGBA4444 (
    set EmWi_GFX_SrcFiles=ewextbmp_RGBA4444.c ewextfnt.c ewextgfx.c ewextpxl_RGBA4444.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
  if %EmWi_ColorFormat% == RGBA8888 (
    set EmWi_GFX_SrcFiles=ewextbmp_RGBA8888.c ewextfnt.c ewextgfx.c ewextpxl_RGBA8888.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
) ELSE (
  set EmWi_RTESrcFiles=ewextrte.c
  set EmWi_RTELibFiles=libewrte-m4-keil.lib
  if %EmWi_SurfaceRotation% == 0 (
    set EmWi_GFX_SrcFiles=ewextgfx.c
    set EmWi_GFX_LibFiles=libewgfx-m4-keil.lib
  ) else (
    set EmWi_GFX_SrcFiles=ewextgfx.c
    set EmWi_GFX_LibFiles=libewgfx-m4-r%EmWi_SurfaceRotation%-keil.lib
  )
)

set parent_path=""
set file_name=""
set file_extension=""
set project_path=""
set project_folder=""
set resolution_folder=""

For %%A in (%EmWi_ProjectFile%) do (
  set parent_path=%%~pA
  set file_name=%%~nA
  set file_extension=%%~xA
)

For %%A in (%parent_path:~0,-1%) do (
  set project_path=%%~pA
  set project_folder=%%~nA
)

For %%A in (%project_path:~0,-1%) do (
  set resolution_folder=%%~nA
)

@echo ^<?xml version="1.0" encoding="UTF-8"?^> > %out_file%
@echo ^<package xmlns:xs="http://www.w3.org/2001/XMLSchema-instance" schemaVersion="1.0" xs:noNamespaceSchemaLocation="PACK.xsd"^> >> %out_file%
@echo   ^<vendor^>TARA Systems^</vendor^> >> %out_file%
@echo   ^<name^>EmWiGeneratedCode^</name^> >> %out_file%
@echo   ^<description^>Generated Code of Embedded Wizard^</description^> >> %out_file%
@echo   ^<url^>https://get.embedded-wizard.de/data/^</url^> >> %out_file%
@echo   ^<releases^> >> %out_file%
@echo     ^<release version="13.3.0"^>- generated by Embedded Wizard post process ^</release^> >> %out_file%
@echo   ^</releases^> >> %out_file%

@echo     ^<generators^> >> %out_file%
@echo       ^<generator id="Embedded_Wizard" Gvendor="TaraSystems GmbH" Gtool="Embedded Wizard" Gversion="13.3.0"^> >> %out_file%
@echo         ^<description^>Embedded Wizard Studio 13.3.0^</description^> >> %out_file%
@echo         ^<workingDir^>%EmWi_InstallDirectory%^</workingDir^> >> %out_file%
@echo         ^<exe^> >> %out_file%
@echo           ^<command host="win"^>%EmWi_InstallDirectory%\EmbeddedWizard.exe^</command^> >> %out_file%
@echo           ^<argument^>$P..\..\..\Examples\%resolution_folder%\%project_folder%\%file_name%%file_extension%^</argument^> >> %out_file%
@echo         ^</exe^> >> %out_file%
@echo       ^</generator^> >> %out_file%
@echo     ^</generators^>  >> %out_file%

@echo   ^<components^> >> %out_file%

@echo     ^<component generator="Embedded_Wizard" Cclass="EmbeddedWizard/GeneratedCode" Cgroup="Open GUI project "^> >> %out_file%
@echo       ^<description^>Opens the GUI project file with Embedded Wizard Studio^</description^> >> %out_file%
@echo     ^</component^> >> %out_file%

@echo     ^<component Cclass="EmbeddedWizard/GeneratedCode" Cgroup="Generated code"^> >> %out_file%
@echo       ^<description^>Embedded Wizard generated GUI source code^</description^> >> %out_file%
@echo       ^<RTE_Components_h^> >> %out_file%
@echo          #define  EW_SURFACE_ROTATION %EmWi_SurfaceRotation% >> %out_file%
@echo          #define  EW_FRAME_BUFFER_COLOR_FORMAT EW_FRAME_BUFFER_COLOR_FORMAT_%EmWi_ColorFormat% >> %out_file%
@echo       ^</RTE_Components_h^> >> %out_file%
@echo       ^<files^> >> %out_file%
@echo         ^<file category="include" name="/"/^> >> %out_file%

for %%i IN (%EmWi_OutputDirectory%\*.c) do (
  set __CURRENT_FILE=%%~ni%%~xi
  @echo         ^<file category="source" name="!__CURRENT_FILE!"/^> >> %out_file% 
)

@echo       ^</files^> >> %out_file%
@echo     ^</component^> >> %out_file%

@echo     ^<component Cclass="EmbeddedWizard/PlatformPackage" Cgroup="Platform package"^> >> %out_file%
@echo       ^<description^>Embedded Wizard Platform Package Libs and Source Code^</description^> >> %out_file%
@echo       ^<RTE_Components_h^> >> %out_file%
@echo       ^</RTE_Components_h^> >> %out_file%
@echo       ^<files^> >> %out_file%

@echo       ^<^^!--  include folder --^> >> %out_file%
@echo         ^<file category="include" name="../../PlatformPackage/RTE/"/^> >> %out_file%
@echo         ^<file category="include" name="../../PlatformPackage/%EmWi_ColorFormat%/"/^> >> %out_file%

for %%f in (%EmWi_RTESrcFiles%) do ( @echo         ^<file category="source" name="../../PlatformPackage/RTE/%%f"/^> >> %out_file% )
for %%f in (%EmWi_GFX_SrcFiles%) do ( @echo         ^<file category="source" name="../../PlatformPackage/%EmWi_ColorFormat%//%%f"/^> >> %out_file% )
for %%f in (%EmWi_RTELibFiles%) do ( @echo         ^<file category="library" name="../../PlatformPackage/RTE/%%f"/^> >> %out_file% )
for %%f in (%EmWi_GFX_LibFiles%) do ( @echo         ^<file category="library" name="../../PlatformPackage/%EmWi_ColorFormat%/%%f"/^> >> %out_file% )

@echo       ^</files^> >> %out_file%
@echo     ^</component^> >> %out_file%

@echo   ^</components^> >> %out_file%

@echo ^</package^> >> %out_file%

set out_file="%EmWi_OutputDirectory%\ewfiles.ipcf"

if not exist "%EmWi_OutputDirectory%/../../PlatformPackage/%EmWi_ColorFormat%" (
echo "ERROR: The requested color format %EmWi_ColorFormat% is not supported for this platform!"
exit /B 1
)

if exist "%EmWi_OutputDirectory%/../../PlatformPackage/%EmWi_ColorFormat%/ewgfx.c" (
  set EmWi_RTESrcFiles=ewcolor.c ewdebug.c ewextrte.c ewobject.c ewpoint.c ewrect.c ewref.c ewresource.c ewscalars.c ewslot.c ewstring.c ewtimer.c

  if %EmWi_ColorFormat% == Index8 (
    set EmWi_GFX_SrcFiles=ewextbmp_Index8.c ewextfnt.c ewextgfx.c ewextpxl_Index8.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
  if %EmWi_ColorFormat% == LumA44 (
    set EmWi_GFX_SrcFiles=ewextbmp_LumA44.c ewextfnt.c ewextgfx.c ewextpxl_LumA44.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
  if %EmWi_ColorFormat% == RGB565 (
    set EmWi_GFX_SrcFiles=ewextbmp_RGB565.c ewextfnt.c ewextgfx.c ewextpxl_RGB565.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
  if %EmWi_ColorFormat% == RGB888 (
    set EmWi_GFX_SrcFiles=ewextbmp_RGB888.c ewextfnt.c ewextgfx.c ewextpxl_RGB888.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
  if %EmWi_ColorFormat% == RGBA4444 (
    set EmWi_GFX_SrcFiles=ewextbmp_RGBA4444.c ewextfnt.c ewextgfx.c ewextpxl_RGBA4444.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
  if %EmWi_ColorFormat% == RGBA8888 (
    set EmWi_GFX_SrcFiles=ewextbmp_RGBA8888.c ewextfnt.c ewextgfx.c ewextpxl_RGBA8888.c ewgfx.c ewgfxattrtext.c ewgfxcore.c ewgfxdriver.c ewgfxtasks.c ewgfxbidi.c
  )
) ELSE (
  set EmWi_RTESrcFiles=ewextrte.c libewrte-m4-iar.a
  if %EmWi_SurfaceRotation% == 0 (
    set EmWi_GFX_SrcFiles=ewextgfx.c libewgfx-m4-iar.a
  ) else (
    set EmWi_GFX_SrcFiles=ewextgfx.c libewgfx-m4-r%EmWi_SurfaceRotation%-iar.a
  )
)


@echo ^<?xml version="1.0" encoding="UTF-8"?^> > %out_file%
@echo ^<^^!-- IAR Project Connection File --^> >>  %out_file%
@echo ^<iarProjectConnection version="1.6" name="EmbeddedWizard" oneShot="false" >>  %out_file%
@echo   xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" >>  %out_file%
@echo   xsi:noNamespaceSchemaLocation="IarProjectConnection_1.6.xsd"^> >>  %out_file%

@echo   ^<includePath^> >>  %out_file%
@echo      ^<path^>$PROJ_DIR$\..\..\..\PlatformPackage\RTE^</path^>  >>  %out_file%

:: The GFX include path has to be set by IAR Project Configuration, since
:: the previous set include path of another color format can not be removed by project connection
:: @echo      ^<path^>$PROJ_DIR$\..\..\..\PlatformPackage\%EmWi_ColorFormat%^</path^>  >>  %out_file%
::

@echo   ^</includePath^> >>  %out_file%

@echo   ^<defines^> >>  %out_file%
@echo     ^<define^>EW_SURFACE_ROTATION=%EmWi_SurfaceRotation%^</define^> >>  %out_file%
@echo     ^<define^>EW_FRAME_BUFFER_COLOR_FORMAT=EW_FRAME_BUFFER_COLOR_FORMAT_%EmWi_ColorFormat%^</define^> >>  %out_file%
@echo   ^</defines^> >>  %out_file%
@echo   ^<files^> >>  %out_file%

@echo     ^<group name="GeneratedCode"^> >>  %out_file%
for %%f in (%EmWi_OutputSrcFiles%) do ( @echo       ^<path^>%%f^</path^> >>  %out_file% )
@echo     ^</group^> >>  %out_file%

@echo     ^<group name="RTE"^> >>  %out_file%
for %%f in (%EmWi_RTESrcFiles%) do ( @echo       ^<path^>../../PlatformPackage/RTE/%%f^</path^> >>  %out_file% )
@echo     ^</group^> >>  %out_file%

@echo     ^<group name="%EmWi_ColorFormat%"^> >>  %out_file%
for %%f in (%EmWi_GFX_SrcFiles%) do ( @echo       ^<path^>../../PlatformPackage/%EmWi_ColorFormat%/%%f^</path^> >>  %out_file% )
@echo     ^</group^> >>  %out_file%

@echo     ^<group name="Header Files"^> >>  %out_file%
@echo     ^</group^> >>  %out_file%
@echo     ^<group name="Library Files"^> >>  %out_file%
@echo     ^</group^> >>  %out_file%
@echo     ^<group name="Documentation" build="false"^> >>  %out_file%
@echo     ^</group^> >>  %out_file%
@echo   ^</files^> >>  %out_file%
@echo ^</iarProjectConnection^> >>  %out_file%

:: IAR workaround GFX include path
if exist "%EmWi_OutputDirectory%\EmWiGfxInclude" (
  rmdir /S /Q "%EmWi_OutputDirectory%\EmWiGfxInclude"
)

mkdir "%EmWi_OutputDirectory%\EmWiGfxInclude"
xcopy /Q "%EmWi_OutputDirectory%\..\..\PlatformPackage\%EmWi_ColorFormat%\*.h" "%EmWi_OutputDirectory%\EmWiGfxInclude"