/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Normal
* Screen size : <480,272>
*
*******************************************************************************/

#ifndef _ApplicationDeviceClass_H
#define _ApplicationDeviceClass_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

#include "_CoreSystemEvent.h"

/* Forward declaration of the class Application::DeviceClass */
#ifndef _ApplicationDeviceClass_
  EW_DECLARE_CLASS( ApplicationDeviceClass )
#define _ApplicationDeviceClass_
#endif


/* This class implements the interface between the GUI application and the device. */
EW_DEFINE_FIELDS( ApplicationDeviceClass, XObject )
  EW_OBJECT  ( HardButtonEvent, CoreSystemEvent )
  EW_PROPERTY( AdcValue,        XInt32 )
  EW_PROPERTY( LedStatus,       XBool )
EW_END_OF_FIELDS( ApplicationDeviceClass )

/* Virtual Method Table (VMT) for the class : 'Application::DeviceClass' */
EW_DEFINE_METHODS( ApplicationDeviceClass, XObject )
EW_END_OF_METHODS( ApplicationDeviceClass )

/* 'C' function for method : 'Application::DeviceClass.Done()' */
void ApplicationDeviceClass_Done( ApplicationDeviceClass _this );

/* 'C' function for method : 'Application::DeviceClass.Init()' */
void ApplicationDeviceClass_Init( ApplicationDeviceClass _this, XHandle aArg );

/* This method is intended to be called by the device driver to notify the GUI application 
   about an alternation of its setting or state value. */
void ApplicationDeviceClass_UpdateAdcValue( ApplicationDeviceClass _this, XInt32 
  aNewValue );

/* Wrapper function for the non virtual method : 'Application::DeviceClass.UpdateAdcValue()' */
void ApplicationDeviceClass__UpdateAdcValue( void* _this, XInt32 aNewValue );

/* The following define announces the presence of the method Application::DeviceClass.UpdateAdcValue(). */
#define _ApplicationDeviceClass__UpdateAdcValue_

/* This method is intended to be called by the device to notify the GUI application 
   about a particular system event. */
void ApplicationDeviceClass_TriggerHardButtonEvent( ApplicationDeviceClass _this );

/* Wrapper function for the non virtual method : 'Application::DeviceClass.TriggerHardButtonEvent()' */
void ApplicationDeviceClass__TriggerHardButtonEvent( void* _this );

/* The following define announces the presence of the method Application::DeviceClass.TriggerHardButtonEvent(). */
#define _ApplicationDeviceClass__TriggerHardButtonEvent_

/* This method implements a device command that calls the underlying device driver 
   to print the given string (e.g. via serial interface). */
void ApplicationDeviceClass_CommandPrint( ApplicationDeviceClass _this, XString 
  aMessage );

/* 'C' function for method : 'Application::DeviceClass.OnSetLedStatus()' */
void ApplicationDeviceClass_OnSetLedStatus( ApplicationDeviceClass _this, XBool 
  value );

/* Default onget method for the property 'AdcValue' */
XInt32 ApplicationDeviceClass_OnGetAdcValue( ApplicationDeviceClass _this );

/* Default onset method for the property 'AdcValue' */
void ApplicationDeviceClass_OnSetAdcValue( ApplicationDeviceClass _this, XInt32 
  value );

/* Default onget method for the property 'LedStatus' */
XBool ApplicationDeviceClass_OnGetLedStatus( ApplicationDeviceClass _this );

#ifdef __cplusplus
  }
#endif

#endif /* _ApplicationDeviceClass_H */

/* Embedded Wizard */
