/*******************************************************************************
*
* E M B E D D E D   W I Z A R D   P R O J E C T
*
*                                                Copyright (c) TARA Systems GmbH
*                                    written by Paul Banach and Manfred Schweyer
*
********************************************************************************
*
* This software is delivered "as is" and shows the usage of Embedded Wizard 
* UI solutions. It is provided as an example software which is intended to be 
* modified and extended according to particular requirements.
* 
* TARA Systems hereby disclaims all warranties and conditions with regard to the
* software, including all implied warranties and conditions of merchantability 
* and non-infringement of any third party IPR or other rights which may result 
* from the use or the inability to use the software.
*
* This file was generated automatically by Embedded Wizard Studio.
*
* Please do not make any modifications of this file! The modifications are lost
* when the file is generated again by Embedded Wizard Studio!
*
* Version  : 13.03
* Screen orientation : Normal
* Screen size : <480,272>
*
*******************************************************************************/

#ifndef _EffectsBoolEffect_H
#define _EffectsBoolEffect_H

#ifdef __cplusplus
  extern "C"
  {
#endif

#include "ewrte.h"
#if ( EW_RTE_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Runtime Environment.
#endif

#include "ewgfx.h"
#if ( EW_GFX_VERSION >> 16 ) != 13
  #error Wrong version of Embedded Wizard Graphics Engine.
#endif

/* Forward declaration of the class Core::Timer */
#ifndef _CoreTimer_
  EW_DECLARE_CLASS( CoreTimer )
#define _CoreTimer_
#endif

/* Forward declaration of the class Effects::BoolEffect */
#ifndef _EffectsBoolEffect_
  EW_DECLARE_CLASS( EffectsBoolEffect )
#define _EffectsBoolEffect_
#endif


/* The class Effects::BoolEffect provides an animation effect intended to toggle 
   a 'bool' value between two values determined by the properties @Value1 and @value2. 
   The effect can 'remote control' a 'bool' property which is referred by the @Outlet 
   property. 
   Beside the both end values, bool animation effects are determined by their duration. 
   The duration is primarily controlled by the value of the property @CycleDuration. 
   This is the time the effect will take for a single animation run. Whether and 
   how often the animation is repeated is stored in the property @NoOfCycles. In 
   this case the property @InterCycleDelay can determine an optional interval to 
   wait between two consecutive animation runs. Finally the property @InitialDelay 
   determines the interval to wait at the very beginning of the effect still before 
   the first animation run began.
   When the effect is finished a signal is send to the slot method stored in the 
   @OnFinished property.
   Whether the effect is running or not is controlled by its property @Enabled. 
   It can be used to start and stop the effect. The effect can also be controlled 
   by sending signals to its @StartEffect and @StopEffect slot methods. */
EW_DEFINE_FIELDS( EffectsBoolEffect, XObject )
  EW_VARIABLE( timer,           CoreTimer )
  EW_PROPERTY( Outlet,          XRef )
  EW_VARIABLE( cycleCounter,    XInt32 )
  EW_VARIABLE( startTime,       XUInt32 )
  EW_PROPERTY( NoOfCycles,      XInt32 )
  EW_PROPERTY( CycleDuration,   XInt32 )
  EW_PROPERTY( Value2,          XBool )
  EW_PROPERTY( Value1,          XBool )
  EW_PROPERTY( Enabled,         XBool )
EW_END_OF_FIELDS( EffectsBoolEffect )

/* Virtual Method Table (VMT) for the class : 'Effects::BoolEffect' */
EW_DEFINE_METHODS( EffectsBoolEffect, XObject )
EW_END_OF_METHODS( EffectsBoolEffect )

/* 'C' function for method : 'Effects::BoolEffect.timerSlot()' */
void EffectsBoolEffect_timerSlot( EffectsBoolEffect _this, XObject sender );

/* 'C' function for method : 'Effects::BoolEffect.OnSetNoOfCycles()' */
void EffectsBoolEffect_OnSetNoOfCycles( EffectsBoolEffect _this, XInt32 value );

/* 'C' function for method : 'Effects::BoolEffect.OnSetCycleDuration()' */
void EffectsBoolEffect_OnSetCycleDuration( EffectsBoolEffect _this, XInt32 value );

/* 'C' function for method : 'Effects::BoolEffect.OnSetEnabled()' */
void EffectsBoolEffect_OnSetEnabled( EffectsBoolEffect _this, XBool value );

/* The slot method 'StartEffect' re-starts the effect if a signal is sent to this 
   slot method. The effect will start from the beginning. */
void EffectsBoolEffect_StartEffect( EffectsBoolEffect _this, XObject sender );

#ifdef __cplusplus
  }
#endif

#endif /* _EffectsBoolEffect_H */

/* Embedded Wizard */
